#include <stdio.h>
#include <stdlib.h>
#include <math.h>

float box_mean(int* box, int box_count);
float box_sd(int* box, int box_count, float mean);

int main (int argc, char** argv)
{
    // the arguments will be row, col, box_size, slope
    int i,j,k,l; //iterators
    int rows = atoi(argv[1]);
    int cols = atoi(argv[2]);
    int box_size = atoi(argv[3]);
    float slope = atof(argv[4]);
    //printf("%d,%d,%d,%f\n",rows,cols,box_size,slope);
    //these first lines are to simply read the data into matrix format
    int** matrix = (int **)malloc(sizeof(int*) * rows);
    float** surface = (float **)malloc(sizeof(float*) * rows);
    //create empty matrix to populate
    for (i = 0; i<rows; i++) {
        matrix[i] = (int *)malloc(sizeof(int) * cols);
        surface[i] = (float *)malloc(sizeof(float) * cols);
        for (j = 0; j<cols; j++) {
            matrix[i][j] = 0;
            surface[i][j] = 0;
        }
    }

    
    FILE *file = fopen ("imagedata.txt", "r");
    int maximumLineLength = 128;
    int row_num = 0;
    int col_num = 0;
    char *lineBuffer = (char *)malloc(sizeof(char) * maximumLineLength);
    for(i=0;i<maximumLineLength;i++){
    	lineBuffer[i]=0;
    }
    char ch = getc(file);
    int count = 0;
    while(ch != EOF){
        if(ch == '\n'){
            int num = atoi(lineBuffer);
            for(i=0;i<maximumLineLength;i++){
    			lineBuffer[i]=0;
    		}
            if (col_num == cols) {
                row_num++;
                col_num=0;
            }
            matrix[row_num][col_num] = num;
            col_num++;
            //printf("%d\n",num);
            count = 0;
        }
        lineBuffer[count] = ch;
        count++;
        ch = getc(file);
    }
    fclose(file);
    //print out matrix
    /*for (i =0; i<rows; i++) {
        for (j=0; j<cols; j++) {
            printf("%d ",matrix[i][j]);
        }
        printf("\n");
    }*/
    
    //now do the threhsolding on the matrix
    for (i=0; i<rows; i++) {
    	/*if (i%100 == 0){
    		printf("%d\n",i);
    	}*/
        for (j=0; j<cols; j++) {
            int box [(int)pow(box_size*2+1,2)];
            int z=0;
            for (z=0; z<box_size*box_size;z++ ) {
                box[z]=0;
            }
            int box_count = 0;
            for (k=i-box_size; k<i+box_size; k++) {
                if (k>=0 && k<rows) {
                    for (l=j-box_size; l<j+box_size; l++) {
                        if (l>=0 && l<cols) {
                            box[box_count] = matrix[k][l];
                            box_count++;
                        }
                    }
                }
            }
            float mean = box_mean(box,box_count);
            float sd = box_sd(box,box_count,mean);
            surface[i][j] = mean + sd*slope;
        }
    }
    // now write the thresholded surface to a file
    FILE *outfile = fopen ("surface.txt", "w");
    for (i=0; i<rows; i++) {
        for (j=0; j<cols; j++) {
            fprintf(outfile,"%f\n",surface[i][j]);
        }
    }
    fclose(outfile);
    return 0;
    
}

float box_mean(int* box,int box_count){
    int i = 0;
    float sum = 0;
    for (i=0; i<box_count; i++) {
        sum+=box[i];
    }
    float mean = sum / (float)box_count;
    return mean;
}

float box_sd(int* box,int box_count, float mean){
    int i = 0;
    float sum = 0;
    for (i=0; i<box_count; i++) {
        sum += pow(((float)box[i]) - mean,2.0);
    }
    float sd = pow(1.0/(box_count-1)*sum,0.5);
    return sd;
}
